#!/usr/bin/env python
# encoding: utf-8
"""

Created by Preston Holmes on 2009-02-01.
Copyright (c) 2009 . All rights reserved.

This python script joins an IRC channel (in this case its hardcoded to #django on freenode)
It will then convert the speech to MP3 and send to an icecast server 

text to speech is OS X provided - so this is a platform specific script

"""

import sys
from voicebot import *
import shout
import time
from subprocess import Popen, PIPE
from threading import Thread, activeCount
from collections import deque
#globals
speech_queue = None
bot_thread = None
ice_thread = None
bot_dead = False

     
class BotThread(Thread):
    def __init__ (self):
        Thread.__init__(self)
        # channel, bot-nick, server, port, owner-nick
        global speech_queue
        
        self.bot = VoiceBot(
            '#django',                  #IRC Channel
            'voicebot',                 #unique nick name for bot
            'irc.freenode.net',         #IRC server
            6667,                       #server port
            owner='yournick',           #your nick (bot only responds to you)
            speech_queue=speech_queue   #the data structure shared by threads
            )
            
            
    def run(self):
        """docstring for run"""
        self.bot.start()

class IceSource(Thread):
    def __init__(self):
        Thread.__init__(self)
        import os.path
        PROJECT_DIR = os.path.dirname(__file__)
        silence_file = os.path.join(PROJECT_DIR,'silence.aiff.mp3')
        beep_file = os.path.join(PROJECT_DIR,'morse.aiff.mp3')
        f = open(silence_file,'rb')
        self.silence = f.read()
        f.close()
        f = open(beep_file,'rb')
        self.beep = f.read()
        f.close()
        s = shout.Shout()
        s.host = 'icecast.example.com'
        s.port = 8000
        s.user = 'source'
        s.password = 'hackme' #the source password as defined in your icecast.xml
        s.mount = "/stream"
        s.format = 'mp3'#'vorbis' | 'mp3'
        # s.protocol = 'http' | 'xaudiocast' | 'icy'
        # s.name = ''
        # s.genre = ''
        # s.url = ''
        # s.public = 0 | 1
        # s.audio_info = { 'key': 'val', ... }
        #  (keys are shout.SHOUT_AI_BITRATE, shout.SHOUT_AI_SAMPLERATE,
        #   shout.SHOUT_AI_CHANNELS, shout.SHOUT_AI_QUALITY)        
        self.broadcast = s
        self.broadcast.open()
        
    def run(self):
        """docstring for run"""
        global speech_queue,bot_thread
        while 1:
            
            if activeCount() < 3:
                #the bot thread has died
                return
            if speech_queue:
                s = speech_queue.pop()
                #print s
                d = Popen('echo "%s" | txt2mp3' % str(s),shell=True,stdout=PIPE,stderr=PIPE).communicate()[0]
                self.broadcast.send(self.beep)
                self.broadcast.set_metadata({'song':s})
                self.broadcast.sync()
                self.broadcast.send(d)
                self.broadcast.sync()
                self.broadcast.send(self.silence)
                self.broadcast.sync()
            else:
                self.broadcast.send(self.silence)
                self.broadcast.sync()
                #speech_queue.write('waiting')

def main():
    global speech_queue, bot_thread, ice_thread
    speech_queue = deque()
    bot_thread = BotThread()
    ice_thread = IceSource()
    bot_thread.start()
    ice_thread.start()
    bot_thread.join()



if __name__ == '__main__':
            main()