#!/usr/bin/env python
# encoding: utf-8
"""
speaklocal.py

Created by Preston Holmes on 2009-02-03.
Copyright (c) 2009 __MyCompanyName__. All rights reserved.

Uses the voicebot but generates the speech locally rather than sending it to icecast
"""

import sys
import os
from voicebot import *
from subprocess import Popen, PIPE
from threading import Thread, activeCount
from collections import deque
import time

speech_queue = None



class BotThread(Thread):
    def __init__ (self,speech_queue):
        Thread.__init__(self)
        # channel, bot-nick, server, port, owner-nick
        self.bot = VoiceBot(
            '#django',                  #IRC Channel
            'voicebot',                 #unique nick name for bot
            'irc.freenode.net',         #IRC server
            6667,                       #server port
            owner='yournick',           #your nick (bot only responds to you)
            speech_queue=speech_queue   #the data structure shared by threads
            )
    def run(self):
        """docstring for run"""
        self.bot.start()

class Speaker(Thread):
    def __init__ (self,speech_queue):
        Thread.__init__(self)
        self.speech_queue = speech_queue
    def run(self):
        while 1:
            if activeCount() < 3:
                return
            if self.speech_queue:
                s = self.speech_queue.pop()
                print s
                d = Popen('say "%s"' % s,shell=True,stdout=PIPE,stderr=PIPE).communicate()[0]
            time.sleep(1)
def main():
    global speech_queue, bot_thread, ice_thread
    speech_queue = deque()
    bot_thread = BotThread(speech_queue)
    speech_thread = Speaker(speech_queue)
    bot_thread.start()
    speech_thread.start()
    #bot_thread.join()
    raw_input('press enter to kill')


if __name__ == '__main__':
    main()

